; rob's 12/8 gym timer thingummy
; $Id: gymtimer.asm,v 1.1 2007/07/06 12:59:47 az Exp $

processor p12f629
#include "p12f629.inc"
	RADIX hex

	__CONFIG _INTRC_OSC_NOCLKOUT & _BODEN_OFF & _MCLRE_ON & _WDT_OFF & _CP_OFF

ABIT	equ	0	;gp0 is green, mode a
BBIT	equ	2	;gp2 is orange, mode b
WBIT	equ	1	;gp1 is yellow, warning mode	

	cblock 0x20
	scritch			; tempvar
	scratch			; tempvar for delay routines
	foo			; tempvar
	endc

	org 0			; power-on or reset
	goto main
	org 0x4			; interrupt table
	retfie			; no ints used

main:	; setup output
	clrf	GPIO
	movlw	7
	movwf	CMCON		; comparator off!
	bsf	STATUS,RP0	; bank1
	movlw	0xff & ~(1<<ABIT|1<<BBIT|1<<WBIT)
	movwf	TRISIO		; those bits output
	bcf	OPTION_REG,INTEDG ; interrupt on gp2 on by default!
	bcf	STATUS,RP0	; back in bank0

	; show some startup indication:	 all leds on for 1s, then 1s off
	movlw	2
	movwf	foo
alive:	movlw	(1<<ABIT|1<<BBIT|1<<WBIT)
	xorwf	GPIO,F
	movlw	.10
	movwf	scritch
delay:	call	delay100ms
	decfsz	scritch,F
	goto delay
	decfsz	foo,F
	goto	alive
	clrf	GPIO

gymloop:
	; 8seconds of mode A
	; 4sec 1hz blink
	; 2sec 2hz blink
	; 2sec 4hz blink and warn on
	movlw	8		; 8x500=4sec
	movwf	scritch
onehza:	
	movlw	(1<<ABIT)
	xorwf	GPIO,F
	movlw	0xfa		; 250ms
	call	delayXms
	movlw	0xfa
	call	delayXms	; 500ms per cycle
	decfsz	scritch,F
	goto	onehza

	movlw	.8		; 8x250=2sec
	movwf	scritch
twohza:	
	movlw	(1<<ABIT)
	xorwf	GPIO,F
	movlw	0xfa		; 250ms
	call	delayXms
	decfsz	scritch,F
	goto	twohza

	movlw	.20		; 16x125=2sec, plus fudge ->2.5s
	movwf	scritch
fourhza:
	movlw	(1<<ABIT)|(1<<WBIT)
	xorwf	GPIO,F
	movlw	0x7d		; 125ms
	call	delayXms
	decfsz	scritch,F
	goto fourhza

	movlw	(1<<ABIT|1<<BBIT|1<<WBIT)
	movwf	GPIO		; all on for 256ms
	clrw
	call	delayXms
	clrf	GPIO

	; 12seconds of mode B
	; 8sec 1hz blink
	; 2sec 2hz blink
	; 2sec 4hz blink and warn on
	movlw	.16		; 16x500=8sec
	movwf	scritch
onehzb:	
	movlw	(1<<BBIT)
	xorwf	GPIO,F
	movlw	0xfa		; 250ms
	call	delayXms
	movlw	0xfa
	call	delayXms	; 500ms per cycle
	decfsz	scritch,F
	goto	onehzb

	movlw	.8		; 8x250=2sec
	movwf	scritch
twohzb:	
	movlw	(1<<BBIT)
	xorwf	GPIO,F
	movlw	0xfa		; 250ms
	call	delayXms
	decfsz	scritch,F
	goto	twohzb

	movlw	.20		; 16x125=2sec, plus fudge ->2.5s
	movwf	scritch
fourhzb:
	movlw	(1<<BBIT)|(1<<WBIT)
	xorwf	GPIO,F
	movlw	0x7d		; 125ms
	call	delayXms
	decfsz	scritch,F
	goto fourhzb

	movlw	(1<<ABIT|1<<BBIT|1<<WBIT)
	movwf	GPIO		; all on for 256ms
	clrw
	call	delayXms
	clrf	GPIO
	
	goto gymloop

#include "delay.inc"
end